Imports System.Windows.Forms

Public Module modMain

   Private WithEvents _Notifyer As New NotifyIcon()
   Private WithEvents mnuHelloWorld As New MenuItem("Hello World!")
   Private WithEvents mnuBeenden As New MenuItem("Beenden")

   Private StartUpTime As TimeSpan

   Public Sub Main()
      With _Notifyer
         .Icon = My.Resources.FACE02
         .Text = "Ein Icon im Systemtray, mit KontextMen"
         .ContextMenu = New ContextMenu(New MenuItem() {mnuHelloWorld, mnuBeenden})
         .Visible = True
      End With
      StartUpTime = Now - Date.MinValue
      ' Hier geht die Anwendung in eine Warteschleife ohne Rckkehr, da
      ' kein MainForm angegeben ist, dessen Schlieen die Rckkehr auslsen wrde
      Application.Run()
   End Sub

   Private Sub Menu_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles mnuHelloWorld.Click, mnuBeenden.Click
      Select Case True
         Case sender Is mnuHelloWorld
            MessageBox.Show("Hello World!")

         Case sender Is mnuBeenden
            'Ressourcenfreigabe: ein polymorphes Array erstellen, mit allen Komponenten, die 
            'IDisposable implementieren - und die in der Schleife disposen
            For Each D As IDisposable In New IDisposable() { _
                  _Notifyer.ContextMenu, _Notifyer, mnuHelloWorld, mnuBeenden}
               D.Dispose()
            Next
            ' das "natrliche" Ende einer Anwendung, nach Schlieen des MainForms, wird hier
            ' notgedrungen etwas forciert.
            Application.Exit()
      End Select
   End Sub

   Private Sub _Notifyer_DoubleClick(ByVal sender As Object, ByVal e As EventArgs) _
         Handles _Notifyer.DoubleClick
      Dialog1.ShowDialog(StartUpTime)
   End Sub

End Module
